# SSHAFT Technology File
# created 8/12/04 by Rhett Davis
#

import os

SSHAFT_HOME = os.environ['SSHAFT_HOME']
PDK_DIR = os.environ['PDK_DIR']

Env = {
  'cadence':{
    'NewEnvVars':['SKIP_CDS_DIALOG', 'CNI_LOG_DEFAULT', 'CDS_LIC_FILE', 'PYTHONHOME', 'CDSHOME', 'MGC_CALIBRE_DRC_RUNSET_FILE', 'OA_HOME', 'PYTHONPATH', 'MGC_CALIBRE_LVS_RUNSET_FILE', 'CNI_PLAT_ROOT', 'MGC_HOME', 'CDS_Netlisting_Mode', 'MGC_STAT_HOME', 'MGC_CALIBRE_PEX_RUNSET_FILE', 'CNI_ROOT', 'LM_LICENSE_FILE', ],
    'AppendEnvVars':['LD_LIBRARY_PATH', ],
    'PrependEnvVars':['PATH', ],
    'SKIP_CDS_DIALOG':'',
    'CNI_LOG_DEFAULT':'/dev/null',
    'CDS_LIC_FILE':'2101@ece-lic-03.ece.ncsu.edu:2101@ece-lic-04.ece.ncsu.edu:2101@ece-lic-05.ece.ncsu.edu',
    'PYTHONHOME':'/afs/bp/contrib/pycell425/.install/linux32/plat_linux_gcc411_32/3rd',
    'CDSHOME':'/afs/eos/dist/cadence2008/ic',
    'MGC_CALIBRE_DRC_RUNSET_FILE':'./.runset.calibre.drc',
    'OA_HOME':'/afs/eos/dist/cadence2010/oa',
    'PYTHONPATH':'/afs/bp/contrib/pycell425/.install/linux32/pylib:/afs/bp/contrib/pycell425/.install/linux32/plat_linux_gcc411_32/pyext:/afs/bp/contrib/pycell425/.install/linux32/plat_linux_gcc411_32/lib:.:'+PDK_DIR+'/ncsu_basekit/techfile/cni:'+PDK_DIR+'/ncsu_basekit/gentech/sshaft/lib/py',
    'MGC_CALIBRE_LVS_RUNSET_FILE':'./.runset.calibre.lvs',
    'CNI_PLAT_ROOT':'/afs/bp/contrib/pycell425/.install/linux32/plat_linux_gcc411_32',
    'MGC_HOME':'/ncsu/calibre20092',
    'CDS_Netlisting_Mode':'Analog',
    'MGC_STAT_HOME':'/ncsu/calibre20092',
    'MGC_CALIBRE_PEX_RUNSET_FILE':'./.runset.calibre.pex',
    'CNI_ROOT':'/afs/bp/contrib/pycell425/.install/linux32',
    'LM_LICENSE_FILE':'/ncsu/calibre20092/licenses/license.dat',
    'LD_LIBRARY_PATH':':/afs/eos/dist/cadence2010/ic/tools/lib:/afs/eos/dist/cadence2010/oa/lib:/afs/bp/contrib/pycell425/.install/linux32/plat_linux_gcc411_32/3rd/lib:/afs/bp/contrib/pycell425/.install/linux32/plat_linux_gcc411_32/3rd/oa/lib/linux_rhel30_gcc411_32/opt:/afs/bp/contrib/pycell425/.install/linux32/plat_linux_gcc411_32/lib',
    'PATH':'/afs/eos/dist/cadence2008/edi/tools/bin:/afs/eos/dist/cadence2010/edi/bin:/afs/bp/contrib/pycell425/.install/linux32/bin:/afs/bp/contrib/pycell425/.install/linux32/plat_linux_gcc411_32/bin:/afs/bp/contrib/pycell425/.install/linux32/plat_linux_gcc411_32/3rd/oa/bin/linux_rhel30_gcc411_32/opt:/afs/bp/contrib/pycell425/.install/linux32/plat_linux_gcc411_32/3rd/bin:/afs/eos/dist/cadence2010/oa/bin:/afs/eos/dist/cadence2010/ic/tools/dfII/bin:/afs/eos/dist/cadence2010/ic/tools/bin:/ncsu/calibre20092/bin:',
  },
  'synopsys':{
    'NewEnvVars':['SYNOPSYS', 'SNPSLMD_LICENSE_FILE', 'LM_LICENSE_FILE', ],
    'AppendEnvVars':['MANPATH', ],
    'PrependEnvVars':['PATH', ],
    'SYNOPSYS':'/ncsu/synopsys',
    'SNPSLMD_LICENSE_FILE':'2012@license1.ece.ncsu.edu,2012@license2.ece.ncsu.edu,2012@license3.ece.ncsu.edu',
    'LM_LICENSE_FILE':'2012@license1.ece.ncsu.edu,2012@license2.ece.ncsu.edu,2012@license3.ece.ncsu.edu',
    'MANPATH':':/ncsu/synopsys/doc/syn/man',
    'PATH':'/ncsu/synopsys/bin/AMD.64:/ncsu/synopsys/bin/IA.32:/afs/bp/dist/synopsys_sold/bin:/ncsu/synopsys/bin:',
  },
  'synopsys_tools':{
    'NewEnvVars':['SNPS_SIMIF', 'SYNOPSYS_CCSS', 'DDD_SESSIONS', 'MTI_PLI', 'VERA_HOME', 'VCS_ARCH_OVERRIDE', 'SNPSLMD_LICENSE_FILE', 'VCS_HOME', 'SYN_TOOLS', 'CCSS_HOME', 'PIONEER_HOME', 'MTB_TPATH', 'CCSS_KEYS', 'DDD_HOME', 'LM_LICENSE_FILE', ],
    'AppendEnvVars':['LD_LIBRARY_PATH', 'MANPATH', ],
    'PrependEnvVars':['PATH', ],
    'SNPS_SIMIF':'/afs/bp.ncsu.edu/dist/synopsys_tools/simif',
    'SYNOPSYS_CCSS':'/ncsu/synopsys_tools/css/linux/ccss',
    'DDD_SESSIONS':'.',
    'MTI_PLI':'/ncsu/synopsys_tools/pioneer_ntb/redhat30/lib/libpioneer_pli_mti.so',
    'VERA_HOME':'/ncsu/synopsys_tools/vera/@sys',
    'VCS_ARCH_OVERRIDE':'redhat30',
    'SNPSLMD_LICENSE_FILE':'2012@license1.ece.ncsu.edu,2012@license2.ece.ncsu.edu,2012@license3.ece.ncsu.edu',
    'VCS_HOME':'/ncsu/synopsys_tools/vcs-mx',
    'SYN_TOOLS':'/ncsu/synopsys_tools',
    'CCSS_HOME':'/ncsu/synopsys_tools/css',
    'PIONEER_HOME':'/ncsu/synopsys_tools/pioneer_ntb',
    'MTB_TPATH':'/ncsu/synopsys_tools/nanochar/nanochar/linux',
    'CCSS_KEYS':'2012@license1.ece.ncsu.edu,2012@license2.ece.ncsu.edu,2012@license3.ece.ncsu.edu',
    'DDD_HOME':'/ncsu/synopsys_tools/css/linux/gnupackages/ddd-3.3.1/share/ddd-3.3.1',
    'LM_LICENSE_FILE':'2012@license1.ece.ncsu.edu,2012@license2.ece.ncsu.edu,2012@license3.ece.ncsu.edu',
    'LD_LIBRARY_PATH':'/ncsu/synopsys_tools/css/linux/gnupackages/lib:/ncsu/synopsys_tools/pioneer_ntb/redhat30/lib:',
    'MANPATH':'/ncsu/synopsys_tools/css/linux/gnupackages/man:/afs/bp.ncsu.edu/dist/synopsys_tools/ns/doc/ns/man:',
    'PATH':'/ncsu/synopsys_tools/css/linux/gnupackages/bin:/ncsu/synopsys_tools/css/linux/ccss/bin:/ncsu/synopsys_tools/pioneer_ntb/bin:/afs/bp.ncsu.edu/dist/synopsys_tools/ns/amd64/ns/bin:/ncsu/synopsys_tools/nanochar/nanochar/linux:/ncsu/synopsys_tools/coreAsm/bin:/ncsu/synopsys_tools/vera/bin:/ncsu/synopsys_tools/vcs-mx/bin:/ncsu/synopsys_tools/star-rcxt/bin:/afs/bp.ncsu.edu/dist/synopsys_tools/simif/bin:/ncsu/synopsys_tools/simif/bin:/ncsu/synopsys_tools/saber/ai_bin:/ncsu/synopsys_tools/pts/bin:/ncsu/synopsys_tools/pps/bin:/ncsu/synopsys_tools/fm/bin:/ncsu/synopsys_tools/esp/bin:/ncsu/synopsys_tools/amps/bin:/afs/bp/dist/synopsys_sold/bin:',
  },
  'calibre':{
    'NewEnvVars':['MGC_HOME', 'MGC_STAT_HOME', 'LM_LICENSE_FILE', ],
    'AppendEnvVars':[],
    'PrependEnvVars':['PATH', ],
    'MGC_HOME':'/ncsu/calibre20092',
    'MGC_STAT_HOME':'/ncsu/calibre20092',
    'LM_LICENSE_FILE':'/ncsu/calibre20092/licenses/license.dat',
    'PATH':'/ncsu/calibre20092/bin:',
  },
}
Apps = {
  'AppList':['cds','enc','dc'],
  'ScriptAppList':['tcl','py'],
  'dc':{
    'TemplateDir':SSHAFT_HOME+'/apps/dc',
    'InitSrcFiles':[ 	'synopsys_dc.setup', 'synopsys_dc.setup.tcl',
			'synopsys_pt.setup', 'synopsys_pt.setup' ],
    'InitDestFiles':[   '.synopsys_dc.setup', '.synopsys_dc.setup.tcl',
			'.synopsys_pt.setup', '.synopsys_pp.setup'],
    'Environment':	'synopsys',
    'CmdParseRegExp': 	r'^(.*)$',
    'CmdLogFormat':	'%s -log %s -la -ll %d -li %d -tol %s',
    'CmdNoLogFormat':	'%s -ll %d -li %d -tol %s',
    'TestCmd':		'substep3',
    'Language': 	'tcl',
    'ExeHeaderFile':	'exe.hdr',
    'ExeFooterFile': 	'exe.ftr',
    'ExecuteCommand':	'dc_shell-t -f exe.tcl',
    'LogCapture':	'dc.out',
    'LogCheck': 	'dc.out',
    'LogCheckRegExp':	r'Error',
    'LogCheckMode': 	'fail',
  },
  'pt':{
    'TemplateDir':      SSHAFT_HOME+'/apps/dc',
    'InitSrcFiles':[ 	'synopsys_dc.setup', 'synopsys_dc.setup.tcl',
			'synopsys_pt.setup', 'synopsys_pt.setup' ],
    'InitDestFiles':[   '.synopsys_dc.setup', '.synopsys_dc.setup.tcl',
			'.synopsys_pt.setup', '.synopsys_pp.setup'],
    'Environment':	'synopsys_tools',
    'CmdParseRegExp': 	r'^(.*)$',
    'CmdLogFormat':	'%s -log %s -la -ll %d -li %d -tol %s',
    'CmdNoLogFormat':	'%s -ll %d -li %d -tol %s',
    'TestCmd':		'substep3',
    'Language': 	'tcl',
    'ExeHeaderFile':	'exe.hdr',
    'ExeFooterFile': 	'exe.ftr',
    'ExecuteCommand':	'pt_shell -f exe.tcl',
    'LogCapture':	'pt.out',
    'LogCheck': 	'pt.out',
    'LogCheckRegExp':	r'Error',
    'LogCheckMode': 	'fail',
  },
  'pp':{
    'TemplateDir':      SSHAFT_HOME+'/apps/dc',
    'InitSrcFiles':[ 	'synopsys_dc.setup', 'synopsys_dc.setup.tcl',
			'synopsys_pt.setup', 'synopsys_pt.setup' ],
    'InitDestFiles':[   '.synopsys_dc.setup', '.synopsys_dc.setup.tcl',
			'.synopsys_pt.setup', '.synopsys_pp.setup'],
    'Environment':	'synopsys_tools',
    'CmdParseRegExp': 	r'^(.*)$',
    'CmdLogFormat':	'%s -log %s -la -ll %d -li %d -tol %s',
    'CmdNoLogFormat':	'%s -ll %d -li %d -tol %s',
    'TestCmd':		'substep3',
    'Language': 	'tcl',
    'ExeHeaderFile':	'exe.hdr',
    'ExeFooterFile': 	'exe.ftr',
    'ExecuteCommand':	'pp_shell -f exe.tcl',
    'LogCapture':	'pp.out',
    'LogCheck': 	'pp.out',
    'LogCheckRegExp':	r'Error',
    'LogCheckMode': 	'fail',
  },
  'enc':{
    'TemplateDir':      SSHAFT_HOME+'/apps/enc',
    'InitSrcFiles':[ 	'encrc' ],
    'InitDestFiles':[   '.encrc' ],
    'Environment':	'cadence',
    'CmdParseRegExp': 	r'^(.*)$',
    'CmdLogFormat':	'set errorflag [catch {%s -log %s -la -ll %d -li %d -tol %s} retval]',
    'CmdNoLogFormat':	'set errorflag [catch {%s -ll %d -li %d -tol %s} retval]',
    'TestCmd':		'substep3',
    'Language': 	'tcl',
    'ExeHeaderFile':	'exe.hdr',
    'ExeFooterFile': 	'exe.ftr',
    'ExecuteCommand':	'encounter -log encounter.log -nowin -overwrite -replay exe.tcl',
    'LogCapture':	'encounter.out',
    'LogCheck': 	'encounter.log',
    'LogCheckRegExp':	r'\*\*ERROR',
    'LogCheckMode': 	'fail',
  },
  'cds':{
    'TemplateDir':      SSHAFT_HOME+'/apps/cds',
    'InitSrcFiles':[ 	'cdsinit', 'cds.lib', 'lib.defs' ],
    'InitDestFiles':[   '.cdsinit', 'cds.lib', 'lib.defs' ],
    'Environment':	'cadence',
    'CmdParseRegExp': 	r'^(.*)\)\s*$',
    'CmdLogFormat':	'%s ?stepargs list( "%s" t %d %d "%s"))',
    'CmdNoLogFormat':	'%s ?stepargs list( nil nil %d %d "%s"))',
    'TestCmd':		'substep3()',
    'Language': 	'il',
    'ExeHeaderFile':	'exe.hdr',
    'ExeFooterFile': 	'exe.ftr',
    'ExecuteCommand':	'virtuoso -log CDS.log -nograph -replay exe.il',
    'LogCapture':	'virtuoso.out',
    'LogCheck': 	'CDS.log',
    'LogCheckRegExp':	r'^\\t t',
    'LogCheckMode': 	'pass',
  },
}

